
/////////////////////////////////////////////////////////////////////////////

var photoAccountWizard = {};

photoAccountWizard.mService = null;
photoAccountWizard.load = function() {
    try {
        var shortName = window.arguments[0];
        // backward compatibility for specifying shortname
        if(shortName.length) {
            this.init(shortName);
            $("photoAccountWizard").goTo("firstPage");
        }
        else {
            // more general parameter object
            var params = window.arguments[0];
            var shortName = params["shortName"];
            this.mAutoImport = params["autoImport"];
            if(shortName) {
                this.init(shortName);
                $("photoAccountWizard").goTo("firstPage");
            }
        }
    }
    catch(e) {
    }
    $("photoAccountWizard").getButton("finish").addEventListener('command', this.finish, false);

    this.buildServiceList();
};

photoAccountWizard.buildServiceList = function() {
    var apimgr = Components.classes['@flock.com/photo-api-manager;1?']
        .getService(Components.interfaces.flockIPhotoAPIManager);
    var listItemTemplate = $("wizardListItemTemplate");
    var list = $("wizardList");
    var stringBundle = document.getElementById('photoAccountBundle');

    while(list.childNodes.length) {
        list.removeChild(list.firstChild);
    }

    var services = apimgr.services;
    while(services.hasMoreElements()) {
        var api = services.getNext();
            var item = listItemTemplate.cloneNode(true);
            list.appendChild(item);
            item.removeAttribute("hidden");
            var checkbox = item.firstChild;
            var label = checkbox.nextSibling;
            checkbox.setAttribute("label", api.serviceName);
            checkbox.setAttribute("value", api.shortName);
            checkbox.setAttribute("src", api.iconUrl);
            checkbox.setAttribute("oncommand", "photoAccountWizard.mShortName='" + api.shortName + '\';$("photoAccountWizard").canAdvance = true;');
    }

    list.selectedIndex = 0;
    photoAccountWizard.mShortName = list.selectedItem.value;
    $("photoAccountWizard").canAdvance = true;
}

photoAccountWizard.init = function(aShortName) {
    var apimgr = Components.classes['@flock.com/photo-api-manager;1?']
        .getService(Components.interfaces.flockIPhotoAPIManager);
    this.mService = apimgr.getAPIFromShortname(aShortName);
    this.setupLabels();
}

////
//  This function iterates through all wizardpages and
//  loades wizard page title values from .properties bundle
//  into those elements.
//  The format for entity names is:
//
//  flock.photo.wizard.X.title
////
photoAccountWizard.setupLabels = function() {
    photoAccountWizard.updateAllDescriptions();
    var stringBundle = document.getElementById('photoAccountBundle');

    var wizardpages = document.getElementsByTagName('wizardpage');
    for (var i=1;i<wizardpages.length;i++) {
      var title = stringBundle.getString('flock.photo.wizard.'+(i+1)+'.title');
      title = title.replace(/%service/, this.mService.serviceName);
      wizardpages[i].setAttribute('label',title);
    }

    $("photoAccountWizard")._adjustWizardHeader();
};

photoAccountWizard.originalValues = [];

////
//  This function iterates through all wizardpages and its
//  description and label elements and loades values from .properties bundle
//  into those elements.
//  The format for entity names is:
//
//  flock.photo.wizard.X.descY
//  flock.photo.wizard.X.labelY
////
photoAccountWizard.updateAllDescriptions = function(aID) {
    var stringBundle = document.getElementById('photoAccountBundle');
    var wizardpages = document.getElementsByTagName('wizardpage');
    for (var i=1;i<wizardpages.length;i++) {
      var elms = wizardpages[i].getElementsByTagName('description');
      for (var v=0;v<elms.length;v++) {
        try {
          var desc = stringBundle.getString('flock.photo.wizard.'+(i+1)+'.desc'+(v+1));
          elms[v].firstChild.nodeValue = desc.replace(/%service/g, this.mService.serviceName);
        } catch (e) {} // if there is no bundle for this, ignore it.
      }
      var elms = wizardpages[i].getElementsByTagName('label');
      for (var v=0;v<elms.length;v++) {
        try {
          var label = stringBundle.getString('flock.photo.wizard.'+(i+1)+'.label'+(v+1));
          elms[v].setAttribute('value',label.replace(/%service/g, this.mService.serviceName));
        } catch (e) {} // if there is no bundle for this, ignore it.
      }
    }
}

photoAccountWizard.unload = function() {
};

photoAccountWizard.finish = function() {
    photoAccountWizard.unload();
    window.close();
    return true;
};

/////////////////////////////////////////////////////////////////////////////
photoAccountWizard.selectionPage = {};

photoAccountWizard.selectionPage.load = function() {
    $("photoAccountWizard").canAdvance = ($("wizardList").selectedIndex>=0?true:false);
    $("photoAccountWizard").canRewind = false;
};

photoAccountWizard.selectionPage.advance = function() {
    photoAccountWizard.init(photoAccountWizard.mShortName);
};
/////////////////////////////////////////////////////////////////////////////
photoAccountWizard.firstPage = {};

photoAccountWizard.firstPage.load = function() {
    $("photoAccountWizard").canAdvance = true;
};

photoAccountWizard.firstPage.advance = function() {

};
/////////////////////////////////////////////////////////////////////////////
photoAccountWizard.waitingForSigninPage = {};

photoAccountWizard.waitingForSigninPage.load = function() {
    $("photoAccountWizard").canAdvance = false;
    $("photoAccountWizard").canRewind = false;
    var authListener = {
        onAuth: function() {
            var apimgr = Components.classes['@flock.com/photo-api-manager;1?']
                .getService(Components.interfaces.flockIPhotoAPIManager);
            apimgr.addPreferredService(photoAccountWizard.mService.shortName);
            apimgr.setDefaultService(photoAccountWizard.mService.shortName);
            $("photoAccountWizard").goTo("successPage");
            $("photoAccountWizard").canAdvance = false;
            $("photoAccountWizard").canRewind = false;
            var ppsvc = Components.classes['@mozilla.org/rdf/datasource;1?name=flock-people-photo'].getService(Components.interfaces.flockIPhotoPeopleService);
            ppsvc.addToRecent(photoAccountWizard.mService.getAuthPerson());
        },
        onError: function(aError) {
            $("photoAccountWizard").goTo("errorSigningInPage");
            $("photoAccountWizard").canAdvance = false;
            $("photoAccountWizard").canRewind = false;
        },
    }
    photoAccountWizard.mService.login(authListener);
};

photoAccountWizard.waitingForSigninPage.advance = function() {

};
/////////////////////////////////////////////////////////////////////////////
photoAccountWizard.successPage = {};

photoAccountWizard.successPage.load = function() {
    if(photoAccountWizard.mService.supportsFeature("contacts")) {
        if(!photoAccountWizard.mAutoImport) {
            $("importContactsButton").removeAttribute("hidden");
            $("successPageWithContacts").removeAttribute("collapsed");
        }
        else {
            photoAccountWizard.successPage.importContacts();
        }
    }
    else {
        $("successPageWithNoContacts").removeAttribute("collapsed");
    }
};

photoAccountWizard.successPage.importContacts = function() {
    $("photoAccountWizard").goTo("importingContactsPage");
    $("photoAccountWizard").canAdvance = false;
    $("photoAccountWizard").canRewind = false;
};

photoAccountWizard.successPage.advance = function() {
};
/////////////////////////////////////////////////////////////////////////////
photoAccountWizard.importingContactsPage = {};
photoAccountWizard.importingContactsPage.load = function() {
    var flockIPhotoPeopleService = Components.interfaces.flockIPhotoPeopleService;
    var flockIPhotoPerson = Components.interfaces.flockIPhotoPerson;

    var ppsvc = Components.classes['@mozilla.org/rdf/datasource;1?name=flock-people-photo']
        .getService(flockIPhotoPeopleService);
    var contactsListener = {
        onGetContactsResult : function(aEnumerator) {
            while(aEnumerator.hasMoreElements()) {
                var person = aEnumerator.getNext();
                person.QueryInterface(flockIPhotoPerson);
                ppsvc.addToList(flockIPhotoPeopleService.LIST_WATCHED, person);
            }
            ppsvc.findNewPhotosForList(flockIPhotoPeopleService.LIST_WATCHED);
            $("photoAccountWizard").goTo("successImportingContactsPage");
            $("photoAccountWizard").canAdvance = false;
            $("photoAccountWizard").canRewind = false;
        },
        onError: function(aError) {
            $("photoAccountWizard").goTo("errorImportingContactsPage");
            $("photoAccountWizard").canAdvance = false;
            $("photoAccountWizard").canRewind = false;
        },
    }
    photoAccountWizard.mService.getContacts(contactsListener);

};

photoAccountWizard.importingContactsPage.advance = function() {
};

