//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005-2006
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//
var gPhotoUploadSvc = null;
var gPhotoMgrSvc = null;
var gSelectedAPI = null;
var gPhotoUploads = null;
var gOldAlbumListener = null;
var gAPIListener = {
    onAPIStateChange: function(aAPI) {
        if(aAPI.isLoggedIn) {
            flock_setCharPref(FLOCK_PREF_PHOTO_API_UINAME, aAPI.shortName);
            gSelectedAPI = aAPI;
            setupAuthenticatedService();
        }
        //setupServicesMenu();
    },
    onError: function(aError) {
    },
}

const ACCOUNT_USAGE_WARNING_THRESHOLD = 0.7;

function unload() {
    gPhotoMgrSvc.removeListener(gAPIListener);
}

function initUploadOptions() {
    gPhotoUploadSvc = Components.classes["@mozilla.org/rdf/datasource;1?name=flock-photo-uploads"]
        .getService(Components.interfaces.flockIPhotoUploadService)
    gPhotoMgrSvc = Components.classes['@flock.com/photo-api-manager;1?']
        .getService(Components.interfaces.flockIPhotoAPIManager);
    
    flock_photoPrefLoad();

    gSelectedAPI =  gPhotoMgrSvc.getDefaultService();
    
    if (!gSelectedAPI) {
       // gPhotoMgrSvc.addListener(gAPIListener);
        //flock.photo.util.launchSettings();
    } else {
       setupAuthenticatedService();
    }
}

function setupAuthenticatedService() {
    setupAlbumList();
    $('uploadSettingsTitle').setAttribute('value', 'Upload settings for ' + gSelectedAPI.serviceName);
    gPhotoUploads = window.arguments[0].photoUploads;
    $('flock-upload-num-photos').setAttribute('value', gPhotoUploads.length);
    flock_SetEstimatedSize();
}

function flock_SetEstimatedSize() {
    var dims = parseInt($('flockPhotoQualityList').selectedItem.value);
    $('flock-upload-estimated-size').setAttribute('value', flock_getBatchUploadSize(dims) + ' MB');
}

function _debug(aStr) {
 dump(aStr + '\n');   
}

function flock_getResizedDims(aDims, aTargetSize) {
    return (aTargetSize*aDims.y)/aDims.x
}

function flock_getBatchUploadSize(aResizeDim, targetSize) {
    var resizeSize = aResizeDim;
    var previewFile;
    var batchUploadFileSize = 0;
    var previewPixelRatio = 0;
    var largestSide = 0;
    var previewDims = 0;
    var originalDims;
    var estimatedSize;
    for (var i=0; i < gPhotoUploads.length; i++) {
     if ($('flockPhotoResizeRadioGroup').selectedItem.id == 'flock-photo-alwaysResize') {
/*
       // calculate the existing pixel to byte ratio
       originalDims = flock.photo.util.getDimensions(gPhotoUploads[i].workingFilePath);
       previewDims =flock.photo.util.getDimensions(gPhotoUploads[i].previewFilePath);
       previewFile = flock.photo.util.getFileFromPath(gPhotoUploads[i].previewFilePath);
       previewPixelRatio = previewFile.fileSize/(previewDims.x * previewDims.y);
       estimatedSize = flock_getResizedDims(originalDims, resizeSize) * resizeSize*previewPixelRatio;
       batchUploadFileSize = batchUploadFileSize + estimatedSize;
*/
       // this is the fast test
       var originalDims = {};
       originalDims.x = aResizeDim;
       originalDims.y = aResizeDim;
       previewPixelRatio = .19;// this is the param to tweak
       estimatedSize = resizeSize * resizeSize*previewPixelRatio;
       batchUploadFileSize = batchUploadFileSize + estimatedSize;
    } else {
        batchUploadFileSize = batchUploadFileSize + flock.photo.util.getFileFromPath(gPhotoUploads[i].originalFilePath).fileSize;
    }
   }
    return (batchUploadFileSize/(1024*1024)).toFixed(1);
}


function flock_photoPrefSetResize(aObj) {   
    if (aObj.selectedItem.id == 'flock-photo-alwaysResize') {
        $("flockPhotoQualityList").removeAttribute("disabled");
        flock_setBoolPref(FLOCK_PREF_PHOTO_RESIZE, true)
    } else {
        $("flockPhotoQualityList").setAttribute("disabled",  true);
        flock_setBoolPref(FLOCK_PREF_PHOTO_RESIZE, false);
    }
}

function flock_disableAlbumSelection(aShouldDisable) {
    if (aShouldDisable) {
        $('flock-photo-albums').setAttribute('disabled', true);
        $('flock-createAlbumBtn').setAttribute('disabled', true);
    } else {
        $('flock-photo-albums').removeAttribute('disabled');
        // special case for photobucket -- this will disappear when album creation is supported
        if (gSelectedAPI.shortName != "photobucket")
          $('flock-createAlbumBtn').removeAttribute('disabled');
    }
}

function flock_photoPrefSetQuality(aValue) {
    flock_setIntPref(FLOCK_PREF_PHOTO_RESIZE_DIMENSIONS, aValue);
}

function flock_photoUploadAccept() {
    flock_savePhotoUploadPrefs();
    window.arguments[0].launchUploader = true;  
    window.arguments[0].apiName=gSelectedAPI.shortName;
    window.arguments[0].resize = $("flockPhotoQualityList").value;
    window.arguments[0].viewService = $("view-after-upload").value;
    if (!$('flock-photo-skipalbum').selected){
        window.arguments[0].albumId = $("flock-photo-albums").value;
    }
    else 
         window.arguments[0].albumId = "";
    return window.arguments[0];
}

function flock_photoUploadCancel() {
    window.arguments[0].launchUploader = false;
}

function flock_savePhotoUploadPrefs() {
    //flock_setCharPref(FLOCK_PREF_PHOTO_API_UINAME, $("flockPhotoservicesList").value);
    flock_setIntPref(FLOCK_PREF_PHOTO_RESIZE_DIMENSIONS, $("flockPhotoQualityList").value);
    flock_setBoolPref(FLOCK_PREF_PHOTO_RESIZE, $("flockPhotoResizeRadioGroup").value=="true");
    flock_setBoolPref('flock.photo.uploader.showPhotosOnUpload', $("view-after-upload").checked);
    flock_setBoolPref('flock.photo.uploader.upload2Album', $('flock-photo-addtoalbum').selected);
}

function flock_photoPrefLoad() {
    var resize = flock_getBoolPref(FLOCK_PREF_PHOTO_RESIZE);
    if(resize=="" || resize==null) {
        flock_setBoolPref(FLOCK_PREF_PHOTO_RESIZE, false);
        resize = flock_getBoolPref(FLOCK_PREF_PHOTO_RESIZE);
    }
    $("flockPhotoResizeRadioGroup").value = resize;
    var viewAfterUpload = flock_getBoolPref('flock.photo.uploader.showPhotosOnUpload');
    $("view-after-upload").checked = viewAfterUpload;
    var maxDim = flock_getIntPref(FLOCK_PREF_PHOTO_RESIZE_DIMENSIONS);
    $("flockPhotoQualityList").value = maxDim;
    //flock_photoPrefSetConfigEnabled();
    var upload2Album = flock_getBoolPref('flock.photo.uploader.upload2Album');
    if (upload2Album) {
        $('flock-photo-addtoalbum').setAttribute('selected', true);
    } else {
        $('flock-photo-skipalbum').setAttribute('selected', true);
        flock_disableAlbumSelection(true);
    }
}

function setupAlbumList() {
    while($("flock-photo-albums-popup").childNodes.length>1) {
        $("flock-photo-albums-popup").removeChild($("flock-photo-albums-popup").lastChild);
    }
    
    $("loading-albums").setAttribute("collapsed", false);
    $("flock-photo-albums").selectedIndex = 0;
    $("flock-photo-albums").setAttribute("disabled", true);
    
     if(gSelectedAPI.shortName) {
        var AlbumListener = function() {}
        AlbumListener.prototype = {
            onGetAlbumsResult: function(aEnumerator) {
                if(this.invalid) return;
                while($("flock-photo-albums-popup").childNodes.length>1) {
                    $("flock-photo-albums-popup").removeChild($("flock-photo-albums-popup").lastChild);
                }
                if ($('flock-photo-addtoalbum').selected)
                    $("flock-photo-albums").removeAttribute("disabled");
                
                $("loading-albums").setAttribute("collapsed", true);
                //var hasAlbum = false;
                while(aEnumerator.hasMoreElements()) {
                    hasAlbum = true;
                    var album = aEnumerator.getNext();
                    album.QueryInterface(Components.interfaces.flockIPhotoAlbum);
                    var menuitem = document.createElement("menuitem");
                    $("flock-photo-albums-popup").appendChild(menuitem);
                    menuitem.setAttribute("label", album.title);
                    menuitem.setAttribute("value", album.id);
                }
                $("flock-photo-albums").selectedIndex = 1;//select the first non-none album
                gSelectedAPI.getAccountStatus(this);
            },
            
            onGetAccountStatus: function(aAccount) {
                var maxSpace = aAccount.maxSpace;
                var usedSpace = aAccount.usedSpace;
                const ONE_MILLION = 1000000;
                
                switch (aAccount.usageUnits) {
                 case "bytes" :
                    maxSpace = Math.round(maxSpace / ONE_MILLION);
                    usedSpace = Math.round(usedSpace / ONE_MILLION);
                 break;
                 
                 case "Megabytes" :
                 
                 break
                 
                 default:
                 
                 break;   
                }
                
                var usageString = usedSpace + '/' + maxSpace + ' MB';
                var usage = (aAccount.usedSpace/aAccount.maxSpace);
                
                $('flock-upload-account-usage').setAttribute('value', (usage*100)+'%');
                $('flock-upload-account-usage-nums').setAttribute('value', usageString);
                $('flock-current-usage').removeAttribute('collapsed');
                // special case for photobucket -- this will disappear when album creation is supported
                if (gSelectedAPI.shortName != "photobucket")
                    $('flock-createAlbumBtn').removeAttribute('disabled');
                
                if (!aAccount.isPremium) {
                    $('flock-photo-pro-message').hidden = false;
                }
                 
                var showUpgradeWarning = usage > ACCOUNT_USAGE_WARNING_THRESHOLD;
                if (!aAccount.isPremium && showUpgradeWarning) {
                    $('flock-photo-upgradeAccountInfo').removeAttribute('hidden');
                    var upgradeString = 'You are running out of space on your ' + gSelectedAPI.serviceName + ' account.';
                    $('flock-photo-upgradeAccountInfoMessage').firstChild.nodeValue = upgradeString;
                }
                
                // special case for Flickr since they allow 3 sets for free accounts
                if (gSelectedAPI.shortName == "flickr" && !aAccount.isPremium && $("flock-photo-albums-popup").childNodes.length > 3) {
                    $('flock-createAlbumBtn').setAttribute('disabled', true); 
                    if(!showUpgradeWarning) {
                        $('flock-photo-upgradeAccountInfo').removeAttribute('hidden');
                        var upgradeString = 'You can only create 3 sets on your free ' + gSelectedAPI.serviceName + ' account. ';
                    $('flock-photo-upgradeAccountInfoMessage').firstChild.nodeValue = upgradeString;
                    }
                        
                }
                window.sizeToContent();    
            },
            
            onError: function(aError) {
                alert("There was an error retrieving your albums!");
            },
        }
        
        if(gSelectedAPI.isLoggedIn) {
            $('flock-createAlbumBtn').setAttribute('disabled', true);
            var listener = new AlbumListener();
            gSelectedAPI.getAlbums(listener);
        }
    }
}

function openCreateAlbumDlg() {
    var windowTitle = "Create New Album"; 
    var text = "Untitled Album"; 
    var rval;
    var popup = $("flock-photo-albums-popup");
    for(;;) {
        rval = prompt("Enter name for the new album:", text, windowTitle, null, null);
        if(rval==null) return;
        var noMatch = true;
        for (var i=0;i<popup.childNodes.length;++i) {
            var child = popup.childNodes.item(i);
            if(child.label==rval) {
                noMatch = false;
                break;
            }
        }
        if(noMatch) break;
        alert("Album already exists. Please choose another name");
    }
    if(rval && rval!=text) {
        //create the album
        var albumListener = {
            onCreateAlbum: function(aAlbum) {
                var menuitem = document.createElement("menuitem");
                var secondItem = $("flock-photo-albums-popup").firstChild.nextSibling;
                if(secondItem==null) {
                    $("flock-photo-albums-popup").appendChild(menuitem);
                }
                else {
                    $("flock-photo-albums-popup").insertBefore(menuitem, secondItem);
                }
                menuitem.setAttribute("label", aAlbum.title);
                menuitem.setAttribute("value", aAlbum.id);
                $("flock-photo-albums").selectedIndex = 1;//select the first non-none album
            },
            onError: function(aError) {
                alert("Error creating album");
            },
        }
        gSelectedAPI.createAlbum(albumListener, rval);
    }
}
